;---------Successful Speedbooster Event PLM------------
;---------------OmegaDragnet9--------------------------
;v-1.1

;This is a functioning Speedbooster Event PLM
;However, it is entirely dependent on the Room Index.

;Unlike the Shotblock PLM this is an all-or-nothing PLM.
;All Speedbooster Event PLMs disappear for good when even one is destroyed. 

;The benefit is you don't waste room states.

;You can technically place Crumble Block B-1F down and it would function the same,
;Except the BTS blocks would return without a room-state.


lorom

!84Freespace1 = $84FDA0
 	
org !84Freespace1

dw Setup1
dw InstList1 

Setup1:  

LDA $079D		;Excellent script from MetroidNerd#9001
JSL $808233		;Check against Event A
BCC +

; Make PLM block air if Event A is already Set
LDX $1C87,y
LDA #$00FF		;Loads Tile in Tilemap. 
STA $7F0002,x
RTS
; Normal PLM Preinstruction
+
LDX $1C87,y 			; PLM's location in the room (nth block * 2)
LDA #$B01F : JSR $82B4 
RTS


InstList1:

DW $86B4				; Sleep


;----------------------------The BTS Code-----------------------------------------------------------

;-------------------------------Defines-------------------------------------------------------------

!84Freespace = $84F870
!94Hijack = $949139		

;-----------------------------Smiley's BTS Formula---------------------------------------------------
;-----------------Comment out if Using Benox50's Extended Event PLM----------------------------------

;Comment these 3 lines if you are using Benox50's Extended Event PLM.
;If you ARE using it, make sure to write $F870 in the appropriate place in
;the "PLMs entries for block collision reaction" table.

!bts = $1F				;Formula credit to Smiley
org !bts*2+!94Hijack	
DW PLM_Value

;---------------------------Speedbooster Event PLM----------------------------------------------------

;Room PLM depends on this for BTS reaction. 

org !84Freespace

PLM_Value:

DW Setup
DW InstList 

Setup:

JSR $CDEA : RTS

InstList:

DW $8C7C		;AudioLibrary
DB $06   
DW $0001,$A345	;Animation frames
DW $0001,$A34B
DW $0001,$A351
DW $0001,$A357
DW .EventInst
DW $86BC            ; Delete

.EventInst

LDA $079D			;Excellent script from MetroidNerd#9001
JSL $808233
BCS +
LDA $079D
JSL $8081FA
;LDA #$0006			;Optional earthquake
;STA $183E
;LDA #$0046 
;STA $1840
;LDA #$0046
;JSL $8090CB
+
RTS











